unit WebCVS1;

{
 Web CVS Repository browser (c)2003 by Paul TOTH <tothpaul@free.fr>
 http://tothpaul.free.fr
}

{
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
interface
}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Edit1: TEdit;
    Memo1: TRichEdit;
    Button1: TButton;
    Memo2: TMemo;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
    { Private declarations }
    hsock:integer;
    server:string;
    URL:string;
    buf:string;
    FileList:TStringList;
    EOF:boolean;
    memoline:string;
    procedure wmuser(var msg:tmessage); message wm_user;
    procedure ThreadProc;
    function HttpServer:string;
    function HttpURL:string;
    procedure Header(path:string);
    procedure getFiles(path:string);
    procedure SendText(s:string);
    function RecvText(EOL:string = #13#10):string;
    procedure Download(FileName:string);
    procedure addMemo(s:string);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses
 winsock;

procedure error(s:string);
begin
 raise exception.create(s);
end;

procedure wserror(s:string);
begin
 error(s+'(WINSOCK #'+IntToStr(WSAGetLastError)+')');
end;

function inet(addr:pchar):integer;
var
 host:PHostEnt;
begin
 result:=inet_addr(addr);
 if result=INADDR_NONE then begin
  host:=gethostbyname(addr);
  if host=nil then error(addr+' : serveur inconnu');
  result:=integer(pointer(host.h_addr^)^);
 end;
end;

function URLDecode(s:string):string;
var
 i:integer;
begin
 Result:=s;
 i:=pos('%',Result);
 while i>0 do begin
  Result[i]:='$';
  Result[i]:=chr(StrToInt(Copy(Result,i,3)));
  Delete(Result,i+1,2);
  i:=pos('%',Result);
 end;
 i:=pos('/',Result);
 while i>0 do begin
  Result[i]:='\';
  i:=pos('/',Result);
 end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 FileList:=TStringList.Create;
end;

procedure TForm1.addmemo(s:string);
begin
 memoline:=s;
 sendmessage(handle,wm_user,0,0);
end;

procedure TForm1.wmuser(var msg:tmessage);
begin
 memo1.lines.add(memoline);
end;

function TForm1.HttpServer:string;
var
 s:string;
 i:integer;
begin
 s:=Edit1.Text;
 i:=pos('://',s);
 if i>0 then Delete(s,1,i+2);
 i:=pos('/',s);
 if i>0 then SetLength(s,i-1);
 Result:=s;
end;

function TForm1.HttpURL:string;
var
 s:string;
 i:integer;
begin
 s:=Edit1.Text;
 i:=pos('://',s);
 if i>0 then Delete(s,1,i+2);
 i:=pos('/',s);
 if i>0 then Delete(s,1,i-1);
 Result:=s;
end;

var
 hThread:THandle;

function StartThread(void:pointer):integer; stdcall;
begin
 Form1.ThreadProc;
 Result:=0;
 CloseHandle(hThread);
end;

procedure TForm1.Button1Click(Sender: TObject);
var
 id:cardinal;
begin
 if Button1.Tag=1 then begin
  Button1.Tag:=2;
  exit;
 end;
 Button1.Tag:=1;
 Button1.Caption:='STOP';
 Server:=HttpServer;
 URL:=HttpURL;
 hThread:=CreateThread(nil,0,@StartThread,nil,0,id);
end;

function NewVersion(FileName,Revision:string):boolean;
var
 path,name:string;
 value:string[10];
begin
 path:=ExtractFilePath(FileName);
 name:=ExtractFileName(FileName);
 value[0]:=chr(GetPrivateProfileString('rev',pchar(name),nil,@value[1],10,pchar(path+'WebCVS.ini')));
 result:=Revision=Value;
end;

procedure SetVersion(FileName,Revision:string);
var
 path,name:string;
begin
 path:=ExtractFilePath(FileName);
 name:=ExtractFileName(FileName);
 WritePrivateProfileString('rev',pchar(name),pchar(Revision),pchar(path+'WebCVS.ini'));
end;

procedure TForm1.ThreadProc;
var
 root:string;
 sock:TSockAddr;
 s,ss,rev:string;
 i:integer;
begin
 try
  FillChar(sock,sizeof(sock),0);
  sock.sin_family:=AF_INET;
  sock.sin_port:=htons(80);
  sock.sin_addr.S_addr:=inet(pchar(Server));

  root:=ExtractFilePath(Application.ExeName);
  SetLength(root,Length(root)-1);

  FileList.Clear;
  FileList.Add(URL);

  while (FileList.Count>0)and(Button1.Tag<2) do begin
   s:=FileList[FileList.Count-1];
   FileList.Delete(FileList.Count-1);
   i:=pos('?',s);
   if i>0 then begin
    ss:=root+URLDecode(Copy(s,1,i-1));
    rev:=copy(s,i,length(s));
    i:=pos('rev=',rev);
    if i=0 then rev:='' else begin
     delete(rev,1,i+3);
     i:=pos('&',rev);
     if i>0 then setlength(rev,i-1);
    end;
    if NewVersion(ss,rev) then begin
   {if FileExists(ss) then begin}
     addmemo('-- '+ss);//memo1.lines.add('-- '+ss);
     Continue;
    end;
   end else
    ss:='';
   try
    hsock:=socket(AF_INET,SOCK_STREAM,IPPROTO_TCP);
    if hsock=INVALID_SOCKET then wserror('erreur TCP/IP');
    if connect(hsock,sock,sizeof(sock))=SOCKET_ERROR then wserror('connexion impossible');
    header(s);
    if ss<>'' then begin
     Download(ss);
     SetVersion(ss,rev);
    end else
     getfiles(s);
   finally
    closesocket(hsock);
   end;
  end;
 finally
  Button1.Caption:='GO';
  Button1.Tag:=0;
  beep;
 end;
end;

procedure TForm1.SendText(s:string);
var
 p:pchar;
 i:integer;
 j:integer;
begin
 s:=s+#13#10;
 p:=@s[1];
 i:=length(s);
 while i>0 do begin
  j:=send(hsock,p^,i,0);
  if j<=0 then wserror('erreur d''criture');
  dec(i,j);
  inc(p,j);
 end;
end;

function TForm1.RecvText(EOL:string=#13#10):string;
var
 tmp:array[1..80] of char;
   i:integer;
begin
 i:=pos(EOL,buf);
 while i=0 do begin
  i:=recv(hsock,tmp,sizeof(tmp),0);
  if i<0 then wserror('erreur de lecture');
  if i=0 then begin
   Result:=buf;
   EOF:=(buf='');
   buf:='';
   exit;
  end;
  buf:=buf+copy(tmp,1,i);
  i:=pos(EOL,buf);
 end;
 result:=copy(buf,1,i-1);
 delete(buf,1,i+Length(EOL)-1);
end;

procedure TForm1.Header(path:string);
var
 s:string;
begin
 buf:='';
 EOF:=False;
 addmemo('>> '+path);//memo1.Lines.Add('>> '+path);
 SendText('GET '+path+' HTTP/1.0');
// SendText('Accept: */*');
// SendText('Connection: Keep-Alive');
// SendText('Host: '+Server);
 SendText('');
 s:=RecvText;
 if pos('200',s)<0 then error(s);
// entte
 memo2.clear;
 repeat
  memo2.Lines.add(s);
  s:=RecvText;
 until s='';
end;

procedure TForm1.getFiles(path:string);
var
 s:string;
 i:integer;
 rev:string;
begin
// body
 rev:='';
 s:=RecvText(#10);
 while not EOF do begin
  i:=pos('<a name="',s);
  if i>0 then begin
   delete(s,1,i+8);
   i:=pos('href="',s);
   if i=0 then begin
    i:=pos('"',s);
    if i>0 then begin
     rev:='href="'+copy(s,1,i-1)+'?rev=';
     //memo1.lines.add('('+rev+')');
    end;
   end else begin
    delete(s,1,i+5);
    i:=pos('"',s);
    FileList.add(path+copy(s,1,i-1));
   end;
  end else
  if rev<>'' then begin
   i:=pos(rev,s);
   if i>0 then begin
    delete(s,1,i+5);
    i:=pos('&',s);
    if i>0 then FileList.add(path+copy(s,1,i-1));
   end;
  end;
  s:=RecvText(#10);
 end;
end;

procedure TForm1.Download(FileName:string);
const
 chunk=512;
var
fs:TFileStream;
 i:integer;
begin
 ForceDirectories(ExtractFilePath(FileName));
 fs:=TFileStream.Create(FileName,fmCreate);
 try
  i:=length(buf);
  if i>0 then fs.WriteBuffer(buf[1],i);
  SetLength(buf,chunk);
  i:=recv(hsock,buf[1],chunk,0);
  while i>0 do begin
   fs.WriteBuffer(buf[1],i);
   i:=recv(hsock,buf[1],chunk,0);
  end;
  if i<0 then wserror('erreur de lecture');
 finally
  fs.Free;
  buf:='';
 end;
end;

var
 wsa:TWSAData;
procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
 CanClose:=Button1.Tag=0;
end;

initialization
 wsaStartup($101,wsa);
end.


